#include <stdio.h>
#include <sys/stat.h>

#define IS_CUBE  0010000   

#define IS_NJ    0000000       
#define IS_WB    0020000        
#define IS_OR    0040000    
#define IS_DA    0060000     

#define IS_NF    0100000 


mode_t get_journal_mode(char * j)
{
    if (strcmp(j, "no_journal") == 0)
	return IS_NJ;
    if (strcmp(j, "writeback") == 0)
	return IS_WB;
    if (strcmp(j, "ordered") == 0)
	return IS_OR;
    if (strcmp(j, "journal") == 0)
	return IS_DA;
}

mode_t get_fsync_mode(char * j)
{
    if (strcmp(j, "no_fsync") == 0)
	return IS_NF;
    else
	return 0;
}


int main(int argc, char *argv[])
{
    int status;
    char *path=NULL;
    mode_t fsync_mode=0;
    mode_t journal_mode=0;
    mode_t mode;
    
    if(argc<4) {
	printf("error: cube pathname journal fsync\n");
	return 0;
    }
    else {
	path = argv[1];
	journal_mode = get_journal_mode(argv[2]);
	fsync_mode = get_fsync_mode(argv[3]);	
    }

    mode = IS_CUBE | journal_mode | fsync_mode | 0777;
    status = mkdir(path, mode);
    printf("result: %d\n", status);
    printf("mode: %o\n", mode);

    return 0;
}
